local AcceptQuest, C_GossipInfo, CompleteQuest, GetNumActiveQuests, GetNumAvailableQuests, GetNumQuestChoices, IsAltKeyDown, IsControlKeyDown, IsQuestCompletable, IsShiftKeyDown, QuestFrameCompleteQuestButton, SelectActiveQuest, SelectAvailableQuest, ShowQuestComplete, UnitName, idTweaks, idTweaksModule, idTweaksOptions, Option, SelectOption, ToggleOption, Questing
do
  local _obj_0 = _G
  AcceptQuest, C_GossipInfo, CompleteQuest, GetNumActiveQuests, GetNumAvailableQuests, GetNumQuestChoices, IsAltKeyDown, IsControlKeyDown, IsQuestCompletable, IsShiftKeyDown, QuestFrameCompleteQuestButton, SelectActiveQuest, SelectAvailableQuest, ShowQuestComplete, UnitName, idTweaks, idTweaksModule, idTweaksOptions = _obj_0.AcceptQuest, _obj_0.C_GossipInfo, _obj_0.CompleteQuest, _obj_0.GetNumActiveQuests, _obj_0.GetNumAvailableQuests, _obj_0.GetNumQuestChoices, _obj_0.IsAltKeyDown, _obj_0.IsControlKeyDown, _obj_0.IsQuestCompletable, _obj_0.IsShiftKeyDown, _obj_0.QuestFrameCompleteQuestButton, _obj_0.SelectActiveQuest, _obj_0.SelectAvailableQuest, _obj_0.ShowQuestComplete, _obj_0.UnitName, _obj_0.idTweaks, _obj_0.idTweaksModule, _obj_0.idTweaksOptions
end
do
  local _obj_0 = idTweaksOptions
  Option, SelectOption, ToggleOption = _obj_0.Option, _obj_0.SelectOption, _obj_0.ToggleOption
end
do
  local _class_0
  local _parent_0 = idTweaksModule
  local _base_0 = {
    set_options = function(self)
      _class_0.__parent.__base.set_options(self)
      self.options:add_option(SelectOption(self, 'pause_key', 'Pause Key', 'While you hold this key nothing will happen', {
        values = {
          shift = 'Shift',
          control = 'Control',
          alt = 'Alt'
        }
      }, { }, 'shift'))
      self.options:add_option(ToggleOption(self, 'accept_quests', 'Accept Quests', 'Accept quests'))
      self.options:add_option(ToggleOption(self, 'complete_quests', 'Complete Quests', 'Automatically complete quests unless when offered a choice of rewards'))
      self.options:add_option(ToggleOption(self, 'complete_gossip', 'Complete Gossip', 'When the gossip window has one option, use it'))
      return self.options:add_option(ToggleOption(self, 'complete_covenant_sanctum', 'Complete Seat of the Primus', 'Automate interactions in the Seat of the Primus'))
    end,
    enable = function(self)
      self.ace_module:RegisterEvent('GOSSIP_SHOW', function(...)
        return self:GOSSIP_SHOW(...)
      end)
      self.ace_module:RegisterEvent('QUEST_AUTOCOMPLETE', function(...)
        return self:QUEST_AUTOCOMPLETE(...)
      end)
      self.ace_module:RegisterEvent('QUEST_COMPLETE', function(...)
        return self:QUEST_COMPLETE(...)
      end)
      self.ace_module:RegisterEvent('QUEST_DETAIL', function(...)
        return self:QUEST_DETAIL(...)
      end)
      self.ace_module:RegisterEvent('QUEST_GREETING', function(...)
        return self:QUEST_GREETING(...)
      end)
      return self.ace_module:RegisterEvent('QUEST_PROGRESS', function(...)
        return self:QUEST_PROGRESS(...)
      end)
    end,
    disable = function(self)
      self.ace_module:UnregisterEvent('GOSSIP_SHOW')
      self.ace_module:UnregisterEvent('QUEST_AUTOCOMPLETE')
      self.ace_module:UnregisterEvent('QUEST_COMPLETE')
      self.ace_module:UnregisterEvent('QUEST_DETAIL')
      self.ace_module:UnregisterEvent('QUEST_GREETING')
      self.ace_module:UnregisterEvent('QUEST_LOG_UPDATE')
      return self.ace_module:UnregisterEvent('QUEST_PROGRESS')
    end,
    should_automate = function(self)
      local output = true
      local key = self.db.profile.pause_key
      if key == 'shift' then
        if IsShiftKeyDown() then
          output = false
        end
      end
      if key == 'control' then
        if IsControlKeyDown() then
          output = false
        end
      end
      if key == 'alt' then
        if IsAltKeyDown() then
          output = false
        end
      end
      return output
    end,
    strip_text = function(self, text)
      if not (text) then
        return 
      end
      text = text:gsub('|c%x%x%x%x%x%x%x%x(.-)|r', '%1')
      text = text:gsub('%[.*%]%s*', '')
      text = text:gsub('(.+) %(.+%)', '%1')
      text = text:trim()
      return text
    end,
    autocomplete_quest = function(self, questId)
      if not (self.db.profile.complete_quests) then
        return 
      end
      return ShowQuestComplete(questId)
    end,
    progress_quest = function(self)
      if not (self.db.profile.complete_quests) then
        return 
      end
      if IsQuestCompletable() then
        return CompleteQuest()
      end
    end,
    complete_quest = function(self)
      if not (self.db.profile.complete_quests) then
        return 
      end
      if GetNumQuestChoices() <= 1 then
        return QuestFrameCompleteQuestButton:Click()
      end
    end,
    accept_quest = function(self)
      if not (self.db.profile.accept_quests) then
        return 
      end
      return AcceptQuest()
    end,
    automate_gossip_window = function(self)
      local num_active_quests = C_GossipInfo.GetNumActiveQuests()
      if num_active_quests > 0 then
        for i = 1, num_active_quests do
          C_GossipInfo.SelectActiveQuest(i)
        end
      end
      local num_available_quests = C_GossipInfo.GetNumAvailableQuests()
      if num_available_quests > 0 then
        for i = 1, num_available_quests do
          C_GossipInfo.SelectAvailableQuest(i)
        end
      end
      num_available_quests = GetNumAvailableQuests()
      if num_available_quests > 0 then
        for i = 1, num_available_quests do
          SelectAvailableQuest(i)
        end
      end
      num_active_quests = GetNumActiveQuests()
      if num_active_quests > 0 then
        for i = 1, num_active_quests do
          SelectActiveQuest(i)
        end
      end
      local num_gossips = C_GossipInfo.GetNumOptions()
      if num_gossips == 1 then
        return C_GossipInfo.SelectOption(1)
      end
    end,
    QUEST_AUTOCOMPLETE = function(self, event, questId)
      if not (self:should_automate()) then
        return 
      end
      return self:autocomplete_quest(questId)
    end,
    QUEST_COMPLETE = function(self, event)
      if not (self:should_automate()) then
        return 
      end
      return self:complete_quest()
    end,
    QUEST_PROGRESS = function(self)
      if not (self:should_automate()) then
        return 
      end
      return self:progress_quest()
    end,
    GOSSIP_SHOW = function(self)
      if not (self:should_automate()) then
        return 
      end
      if self.db.profile.complete_covenant_sanctum and 'Arkadia Moa' == UnitName('target') then
        C_GossipInfo.SelectOption(1)
        return 
      end
      return self:automate_gossip_window()
    end,
    QUEST_GREETING = function(self, ...)
      if not (self:should_automate()) then
        return 
      end
      return self:automate_gossip_window()
    end,
    QUEST_DETAIL = function(self)
      if not (self:should_automate()) then
        return 
      end
      return self:accept_quest()
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, addon)
      return _class_0.__parent.__init(self, addon, 'Questing', 'AceConsole-3.0', 'AceEvent-3.0')
    end,
    __base = _base_0,
    __name = "Questing",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Questing = _class_0
end
return idTweaks:add_module(Questing(idTweaks))
